import React from 'react';
import { Modal } from 'antd';
import QRCode  from 'qrcode.react';

function SiderBarShareModal({visible,urlValue,onCancel}) {
  return(
    <Modal
      title={"分享到微信"}
      visible={visible}
      width="500px"
      closable={true}
      footer={false}
      onCancel={onCancel}
    >
      <div style={{textAlign:"center"}}>
        {urlValue &&<QRCode
          value={urlValue}
          size={200}
          fgColor="#000000"
          style={{margin:"0 20px 20px"}}
        />}
        <p>打开微信“扫一扫”，点击右上角菜单，即可将网页分享至朋友圈</p>
      </div>
    </Modal>
  )
}
export default SiderBarShareModal;