import { notification ,message} from 'antd';
import axios from 'axios';
import cookie from 'react-cookies';
import Login from './Wiki/components/Login';

export const TokenKey = 'autologin_trustie';

export default function javaFetch(actionUrl){
  if (window.location.href.indexOf('localhost') < 0) {
    axios.defaults.withCredentials = true;
  }
  
  // 创建axios实例
  const service = axios.create({
    baseURL: actionUrl,
    timeout: 1800000, // 请求超时时间
  });
  
  // request拦截器
  service.interceptors.request.use(config => {
    if (cookie.load(TokenKey)) {
      console.log(cookie.load(TokenKey));
      config.headers['Authorization'] = cookie.load(TokenKey); // 让每个请求携带自定义token 请根据实际情况自行修改
    }
    if (window.location.port === "3007") {
      // 模拟token为登录用户
      const token = sessionStorage.token;
      if (config.url.indexOf('?') === -1) {
        config.url = `${config.url}?token=${token}`;
      } else {
        config.url = `${config.url}&token=${token}`;
      }
    }
    return config;
  }, error => {
    console.log(error); // for debug
    // Promise.reject(error);
  });
  // respone拦截器
  service.interceptors.response.use(
    response => {
      const res = response||{};
      if (res.status === 400) {
        message.error(res.data.message || '操作失败');
        return Promise.reject('error');
      }
      if (res.status === 401) {
        message.error(res.data.message || '登录信息已过期');
        return Promise.reject('error');
      }
      if (res.status === 403) {
        message.error(res.data.message || '无权限！');
        return Promise.reject('error');
      }
      if (res.status === 40001) {
        notification.open({
          message: "提示",
          description: '账户或密码错误！',
        });
        return Promise.reject('error');
      }
      if (response.status !== 200 && res.status !== 200) {
        notification.open({
          message: "提示",
          description: res.message,
        });
      } else {
        return response.data;
      }
    },
    error => {
      console.log(error);
      let res = error.response||{};
      if (res.status === 400) {
        message.error(res.data.message || '操作失败');
        return Promise.reject('error');
      }
      if (res.status === 401) {
        message.error(res.data.message || '登录信息已过期');
        Login();
        return Promise.reject('error');
      }
      if (res.status === 403) {
        message.error(res.data.message || '无权限！');
        return Promise.reject('error');
      }
      notification.open({
        message: "提示",
        description: error.message,
      });
      return Promise.reject(error);
    }
  );


  return service;
}